/* 
  Author: Connor Kippes

  General CSS for all pages.
*/

/* import for roboto font */
@import url("https://fonts.googleapis.com/css2?family=Roboto:wght@300;600&display=swap");

:root {
    --footer-bg-color: rgb(240, 240, 240);
    --main-bg-color: white; /* white background to not take away from art and for a clean, modern look */
    --text-color: rgb(
        50,
        50,
        50
    ); /* medium gray for text to not be easy to read and not harsh on the eyes */
    --accent-color: #5faba8; /* Teal - calm, creative, modern */ /* Alternate Color: #8FAE92; /* Sage Green*/
    --accent-color-faded: rgba(95, 171, 168, 0.5);

    --green: #5fa86a;
    /* --red: #f44336; */
    --red: #f14848;
    /* --orange: #ff9800; */
    --orange: #d4722a;
    --yellow: #d4c42a;

    /* dark theme */
    /*
    --footer-bg-color: rgb(31, 31, 31);
    --main-bg-color: rgb(26, 26, 26);
    --text-color: white;
    --accent-color: #8FAE92;
    */

    /* old theme- blue, green */
    /*
    --footer-bg-color: #154851;
    --main-bg-color: #237a85; 
    --text-color: #e0ffd6;
    --accent-color: #baf8a0;
    */
    --ff: "Roboto";
    --h1: bold 2.441rem/1.2 var(--ff);
    --h2: bold 1.953rem/1.25 var(--ff);
    --big-p: 1.25rem/1.875rem var(--ff);
    --p: 1rem/1.6 var(--ff);
    --links: 1rem/1 var(--ff);
    --subtext: 0.8rem/1.5 var(--ff);

    /* --ff: "Roboto";
    --h1: bold 3rem/3.5rem var(--ff);
    --h2: bold 2rem/2.5rem var(--ff);
    --big-p: 1.3125rem/1.875rem var(--ff);
    --links: bold 1rem/1rem var(--ff);
    --p: 1.125rem/1.875rem var(--ff);
    --button-text: 1.3125rem/1.3125rem var(--ff);
    --subtext: 0.84375rem/1.25rem var(--ff); */

    --box-shadow: 0.5rem 0.5rem 1rem rgba(0, 0, 0, 0.3);
    --box-shadow2: 0 0.5rem 1.5rem rgba(0, 0, 0, 0.2); /* less shadow */
    --border: 1px solid rgba(0, 0, 0, 0.2);
    --border-radius: 0.5rem;
}

/*-------debugging--------*/

/*
* {
  outline: 1px solid red;
}
*/

/*-------layout--------*/
body,
html {
    margin: 0;
    padding: 0;
    overflow-x: hidden;
}

*,
*::before,
*::after {
    box-sizing: border-box;
}

body {
    background-color: var(--main-bg-color);
    color: var(--text-color);
    font-family: var(--ff);
    font-weight: 300;
}

#page-wrapper {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    min-height: 100vh;
    width: 100%;
    margin: 0px;
    padding: 0px;
}

main {
    margin: 7.8125rem auto;
    max-width: 67.5rem;
    flex-grow: 1;
}

/*------Typography---*/

h1 {
    font: var(--h1);
    color: var(--accent-color);
}
h2 {
    font: var(--h2);
    color: var(--accent-color);
}
h3 {
    font: var(--h3);
    color: var(--text-color);
}
p {
    font: var(--p);
    color: var(--text-color);
}
.big-p {
    font: var(--big-p);
    color: var(--text-color);
}
.subtext {
    font: var(--subtext);
    color: var(--text-color);
}
a {
    color: var(--text-color);
    text-decoration: none;
    cursor: pointer;
}
a:hover {
    text-decoration: underline;
}

/*---helper----*/
.center-text {
    text-align: center;
}
.hover-shadow {
    transition: box-shadow 0.3s ease;
}
.hover-shadow:hover {
    box-shadow: var(--box-shadow);
}
.big-spacer {
    height: 3rem;
}
.small-spacer {
    height: 1rem;
}
.none {
    display: none !important;
}
.bold {
    font-weight: bold !important;
}

.icon {
    min-width: 2rem;
    width: 2rem;
    min-height: 2rem;
    height: 2rem;
    fill: var(--text-color);
    transition:
        transform 0.2s ease,
        fill 0.2s ease;
    cursor: pointer;
}

.text-input {
    width: 100%;
    padding: 0.75rem;
    border: var(--border);
    font: var(--links);
    color: var(--text-color);
    background: var(--main-bg-color);
    border-radius: var(--border-radius);
}

.text-input:focus {
    outline: none;
    border-color: var(--accent-color);
}

.green-bg {
    background-color: var(--green);
}
.red-bg {
    background-color: var(--red);
}
.orange-bg {
    background-color: var(--orange);
}

/*--------Element changes----------*/

button {
    border: none;
    padding: 0.75rem 4.5rem;
    max-width: 100%;
    background-color: var(--accent-color);
    color: var(--main-bg-color);
    font: var(--links) !important;
    text-align: center;
    border-radius: var(--border-radius);
    cursor: pointer;
}
button:hover {
    filter: brightness(1.125);
}
img {
    max-width: 100%;
    border-radius: var(--border-radius);
}

/* -----------Toast---------*/
#toast-container {
    position: fixed;
    bottom: 1.5rem;
    right: 1.5rem;
    display: flex;
    flex-direction: column-reverse; /* newest at bottom */
    gap: 1rem;
    z-index: 9999;
}

.toast {
    white-space: nowrap;
    position: relative;
    display: inline-block;
    padding: 1rem;
    border-radius: var(--border-radius);
    box-shadow: var(--box-shadow2);
    background-color: var(--text-color);
    color: var(--main-bg-color);
    text-align: center;

    /* start below */
    transform: translateY(100%);
    opacity: 0;
    animation: slideUp 0.35s ease forwards;
}

.toast-success {
    background-color: var(--green);
}

.toast-error {
    background-color: var(--red);
}

.toast-warning {
    background-color: var(--orange);
}

/* --------Modal----------*/
#modal-container {
    display: flex;
    align-items: center;
    justify-content: center;
    z-index: 9999;
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(0, 0, 0, 0.5);
}

#modal-content {
    display: flex;
    flex-direction: column;
    align-items: center;
    gap: 2rem;
    background-color: var(--main-bg-color);
    padding: 3rem;
    box-shadow: var(--box-shadow2);
    text-align: center;
}

.modal-button-container {
    display: flex;
    flex-direction: column;
    gap: 1rem;
    width: max-content;
}

.modal-button-container button {
    width: 100%;
}

/* slide up animation */
@keyframes slideUp {
    to {
        transform: translateY(0);
        opacity: 0.95;
    }
}

/* -----------Obsverver---------*/
.hidden {
    opacity: 0;
    transform: translateY(20px);
    transition:
        opacity 0.85s ease-in,
        transform 0.85s ease-in;
}

.hidden.show {
    opacity: 1;
    transform: translateY(0);
}

.flex-column {
    display: flex;
    flex-direction: column;
    align-items: center;
}

@media (max-width: 768px) {
    button {
        padding: 0.75rem 3.5rem;
    }
}
